function [ C ] = bbx2ell( BB , sz)
%FROMBB2ELL Summary of this function goes here
%   Detailed explanation goes here
% plane q is tangent to the conic when:
% 0 = q S^-1 q^t
%   = q M^-1 M S^-1 M^t M^t^-1 q^t
%   = (q M^-1) (M S^-1 M^t) (q M^-1)^t
% 
% transformed plane (q M^-1) should preserve incidence
% -> dual conic transformed by matrix M is:  (M S^-1 M^t)

% BB = [xmin ymin xmax ymax]
if nargin<2
    sz='out';
end

if strcmp(sz,'out')
    a   = sqrt(2)*abs(BB(3)-BB(1))/2;
    b   = sqrt(2)*abs(BB(4)-BB(2))/2;
else
    a   = abs(BB(3)-BB(1))/2;
    b   = abs(BB(4)-BB(2))/2;
end

x0  = [(BB(1)+BB(3))/2 (BB(2)+BB(4))/2];
Ccn = [diag([1/a^2 1/b^2]),[0 0]';[0 0 -1]];
P   = [eye(2),x0';[0 0 1]];
% Cinv = P*(Ccn^(-1)*det(Ccn))*P';
Cinv = P*(Ccn^(-1))*P';
Cinv = 0.5*(Cinv + Cinv');
C = Cinv/Cinv(3,3);
C = C*sign(sum(diag(C(1:2,1:2))));

end