function [ Qadj ] = newRegF( P, C, proj )
%NEWREGF 

views = size(C,1)/3;
% Initialization
M   = zeros(6*views,10+views);

% Get B matrices
for n = 1:views
       
    %[D1,C0] = cart2homo( C(3*n-2:3*n,1:3) );

    C0      = C(3*n-2:3*n-1,3);
    % Centering the ellipses
    
    T       = [eye(2),C0;0 0 1]^(-1);
        
    % Get B matrices ----------------------------
    if strcmp(proj,'ortho')
        % P_fr   = proj2ortho( P(n*4-3:n*4,1:3) );
        P_fr   = [P(n*4-3:n*4,1:2),[0 0 0 1]']*T';
    elseif strcmp(proj,'persp')
        P_fr   = P(n*4-3:n*4,1:3)*T';
    end
    
    vecP    = Pvectz(P_fr);
    B       = computeB(vecP);
    
    % Get Cdual vectors -------------------------
    C_t     = T*C(3*n-2:3*n,1:3)*T';
    C_tv    = sym2vec(C_t);
    C_tv    = C_tv/C_tv(end);

    % Matrix without regularization
    M(6*n-5:6*n,1:10) = B;
    M(6*n-5:6*n,10+n) = -C_tv;
end

[~,~,V] = svd(M);
w       = V(:,end);
wsol    = w(1:10)/w(10);

Qtmp    = invAdj(vec2sym(wsol));
Qtmp    = Qtmp/sign(Qtmp(1,1));
[ A2,Cx]= cart2homo( Qtmp );
[R2,D2] = eig(A2);
a01     = (sqrt(abs(-det(Qtmp)/(det(Qtmp(1:3,1:3))*D2(1,1)))));
b01     = (sqrt(abs(-det(Qtmp)/(det(Qtmp(1:3,1:3))*D2(2,2)))));
c01     = (sqrt(abs(-det(Qtmp)/(det(Qtmp(1:3,1:3))*D2(3,3)))));

t10     = Cx(1);
t20     = Cx(2);
t30     = Cx(3);

[~,sortI]   = sort([a01,b01,c01]);
ax02        = [1.3591/2,1.5576/2,3.5303/2];
ax02s       = ax02(sortI);

gamma01  = rotro2eu('zyx',R2);

% associate the initialization axes with respect to the found one

syms gamma1 gamma2 gamma3
syms a b c
t = sym('t',[3,1]);
lambda = sym('lambda',[views,1]);

% initialization

options = optimset('GradObj','on',...
                   'Display','off','MaxIter',100,...
                   'TolX',1e-4,'TolFun',1e-5,'MaxFunEvals',50000);
lb      = [+1.2*ones(1,3) -inf*ones(1,3)  -inf*ones(1,3) -inf*ones(1,views)];
ub      = [ +3.0*ones(1,3) +inf*ones(1,3)  +inf*ones(1,3) +inf*ones(1,views)];
x0      = [a01 b01 c01 gamma01(1) gamma01(2) gamma01(3) t10 t20 t30 w(11:end)'/w(10)];
x       = [a b c gamma1 gamma2 gamma3 t' lambda' ]';
Mf      = M;

fileID = fopen('temp.txt','w');

%[xfinal, fval, exitflag, output] = fmincon(@(x)funRegL2(Mf,fileID,x,views),x0',[],[],[],[],lb,ub,[],options);
[xfinal, fval, exitflag, output] = fmincon(@(x)funRegL2(Mf,fileID,x,views),x0',[],[],[],[],[],[],[],options);

fclose(fileID);

% Generate final matrix from the final solution

gammaf1 = xfinal(4);
gammaf2 = xfinal(5);
gammaf3 = xfinal(6);
tfin    = xfinal(7:9);

Hf      = [[-cos(gammaf3) ^ 2 * cos(gammaf2) ^ 2 -(-sin(gammaf3) * cos(gammaf1) + cos(gammaf3) * sin(gammaf2) * sin(gammaf1)) ^ 2 -(sin(gammaf3) * sin(gammaf1) + cos(gammaf3) * sin(gammaf2) * cos(gammaf1)) ^ 2 tfin(1) ^ 2; -cos(gammaf3) * cos(gammaf2) ^ 2 * sin(gammaf3) -(-sin(gammaf3) * cos(gammaf1) + cos(gammaf3) * sin(gammaf2) * sin(gammaf1)) * (cos(gammaf3) * cos(gammaf1) + sin(gammaf3) * sin(gammaf2) * sin(gammaf1)) -(sin(gammaf3) * sin(gammaf1) + cos(gammaf3) * sin(gammaf2) * cos(gammaf1)) * (-cos(gammaf3) * sin(gammaf1) + sin(gammaf3) * sin(gammaf2) * cos(gammaf1)) tfin(1) * tfin(2); cos(gammaf3) * cos(gammaf2) * sin(gammaf2) -(-sin(gammaf3) * cos(gammaf1) + cos(gammaf3) * sin(gammaf2) * sin(gammaf1)) * cos(gammaf2) * sin(gammaf1) -(sin(gammaf3) * sin(gammaf1) + cos(gammaf3) * sin(gammaf2) * cos(gammaf1)) * cos(gammaf2) * cos(gammaf1) tfin(1) * tfin(3); 0 0 0 tfin(1); -sin(gammaf3) ^ 2 * cos(gammaf2) ^ 2 -(cos(gammaf3) * cos(gammaf1) + sin(gammaf3) * sin(gammaf2) * sin(gammaf1)) ^ 2 -(-cos(gammaf3) * sin(gammaf1) + sin(gammaf3) * sin(gammaf2) * cos(gammaf1)) ^ 2 tfin(2) ^ 2; sin(gammaf3) * cos(gammaf2) * sin(gammaf2) -(cos(gammaf3) * cos(gammaf1) + sin(gammaf3) * sin(gammaf2) * sin(gammaf1)) * cos(gammaf2) * sin(gammaf1) -(-cos(gammaf3) * sin(gammaf1) + sin(gammaf3) * sin(gammaf2) * cos(gammaf1)) * cos(gammaf2) * cos(gammaf1) tfin(2) * tfin(3); 0 0 0 tfin(2); -sin(gammaf2) ^ 2 -cos(gammaf2) ^ 2 * sin(gammaf1) ^ 2 -cos(gammaf2) ^ 2 * cos(gammaf1) ^ 2 tfin(3) ^ 2; 0 0 0 tfin(3); 0 0 0 1;] zeros(10,views); zeros(views,4), eye(views)];
Af      = [xfinal(1)^2 xfinal(2)^2 xfinal(3)^2 1 xfinal(10:end)']';
wfin    = Hf*Af; 
Qadjv   = wfin(1:10)/wfin(10);
Qadj    = vec2sym(Qadjv);

end
